package org.dromara.zhishu.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.dromara.zhishu.domain.ShopImg;
import org.springframework.stereotype.Service;
import org.dromara.zhishu.domain.bo.NoticeBo;
import org.dromara.zhishu.domain.vo.NoticeVo;
import org.dromara.zhishu.domain.Notice;
import org.dromara.zhishu.mapper.NoticeMapper;
import org.dromara.zhishu.service.INoticeService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 消息通知Service业务层处理
 *
 * @author yxy
 * @date 2025-05-17
 */
@RequiredArgsConstructor
@Service
public class NoticeServiceImpl implements INoticeService {

    private final NoticeMapper baseMapper;

    /**
     * 查询消息通知
     *
     * @param id 主键
     * @return 消息通知
     */
    @Override
    public NoticeVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询消息通知列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 消息通知分页列表
     */
    @Override
    public TableDataInfo<NoticeVo> queryPageList(NoticeBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<Notice> lqw = buildQueryWrapper(bo);
        Page<NoticeVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的消息通知列表
     *
     * @param bo 查询条件
     * @return 消息通知列表
     */
    @Override
    public List<NoticeVo> queryList(NoticeBo bo) {
        LambdaQueryWrapper<Notice> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<Notice> buildQueryWrapper(NoticeBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<Notice> lqw = Wrappers.lambdaQuery();
        lqw.orderByDesc(Notice::getCreateTime);
        lqw.eq(StringUtils.isNotBlank(bo.getSender()), Notice::getSender, bo.getSender());
        lqw.eq(StringUtils.isNotBlank(bo.getRecipient()), Notice::getRecipient, bo.getRecipient());
        lqw.eq(StringUtils.isNotBlank(bo.getContent()), Notice::getContent, bo.getContent());
        lqw.eq(StringUtils.isNotBlank(bo.getStatus()), Notice::getStatus, bo.getStatus());
        lqw.eq(bo.getCreateTime() != null, Notice::getCreateTime, bo.getCreateTime());
        return lqw;
    }

    /**
     * 新增消息通知
     *
     * @param bo 消息通知
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(NoticeBo bo) {
        Notice add = MapstructUtils.convert(bo, Notice.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改消息通知
     *
     * @param bo 消息通知
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(NoticeBo bo) {
        Notice update = MapstructUtils.convert(bo, Notice.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(Notice entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除消息通知信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
